<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Practice</title>

    <style>
        #notification-ok {
            color: green;
        }

        #notification-error {
            color: red;
        }
    </style>
</head>
<body>
<h2>HTML Forms</h2>

<form id="form1" name="form1" action="#">
    <label for="name">Name:</label><br>
    <input type="text" id="name" name="name" value=""><br>
    <label for="email">Email:</label><br>
    <input type="text" id="email" name="email" value=""><br>
    <label for="age">Age:</label><br>
    <input type="number" id="age" name="age" value="0"><br><br>

    <label for="gender">Gender:</label>
    <select id="gender" name="gender">
        <option disabled selected value> -- select an option --</option>
        <option value="Male">Male</option>
        <option value="Female">Female</option>
        <option value="Other">Other</option>
    </select><br><br>

    <p> Choose your hobby: </p>
    <input type="radio" id="reading" name="hobby" value="reading">
    <label for="reading">reading</label><br>
    <input type="radio" id="fishing" name="hobby" value="fishing">
    <label for="fishing">fishing</label><br>
    <input type="radio" id="sleeping" name="hobby" value="sleeping">
    <label for="sleeping">sleeping</label><br><br>

    <input id="form-submit" type="submit" onclick="validateForm()" value="Submit">

    <div id="notification-ok" style="display: none;">
        OK
    </div>
    <div id="notification-error" style="display: none;">
    </div>
</form>

<script>
    document.getElementById("form-submit").addEventListener("click", function (event) {
        event.preventDefault()
    });

    function validateForm() {
        document.getElementById("notification-ok").style.display = 'none';
        document.getElementById("notification-error").style.display = 'none';
        const errors = [];

        let name = document.getElementById("name").value;
        if (name.trim().length < 2 || name.trim().length > 10) {
            errors.push('Name length is not valid.')
        }

        let age = document.getElementById("age").value;
        if (age <= 0 || age > 50) {
            errors.push('Age is not valid.')
        }

        let email = document.getElementById("email").value;
        if (!validateEmail(email)) {
            errors.push('Email is not valid.')
        }

        let genderElement = document.getElementById("gender");
        let gender = genderElement.value
        if (gender !== 'Male' && gender !== 'Female' && gender !== 'Other') {
            errors.push('Gender is not valid.')
        }

        let hobbyElement = document.getElementById("form1").querySelector('input[name=hobby]:checked');
        let hobby;
        if (hobbyElement !== null) {
            hobby = hobbyElement.value;
        } else {
            hobby = '';
        }
        if (hobby !== 'reading' && hobby !== 'fishing' && hobby !== 'sleeping') {
            errors.push('Hobby is not valid.')
        }

        if (errors.length === 0) {
            document.getElementById("notification-ok").style.display = "";
        } else {
            let errorElements = "";
            for (let error of errors) {
                errorElements = errorElements + `
                    <li>${error}</li>
                `;
            }
            
            document.getElementById("notification-error").style.display = "";
            document.getElementById("notification-error").innerHTML = `<ul>${errorElements}</ul>`;
        }
    }

    function validateEmail(email) {
        if (email.trim().length === 0) {
            return false;
        }
        const emailRegex = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
        return email.match(emailRegex);
    }

</script>

</body>

</html>

<!-- 
1. Name: 2 < length < 10. required
2. email: pattern xxx@xxx.xxx. required
3. age: is Number. 0 < age < 50. required
4. Gender: Male / Female / Other. required.
5. Hobby: required. reading/fishing/sleeping
-->